Index: /trunk/ARCH/arch-ADASTRA-gnu.env
===================================================================
--- /trunk/ARCH/arch-ADASTRA-gnu.env	(revision 2978)
+++ /trunk/ARCH/arch-ADASTRA-gnu.env	(revision 2978)
@@ -0,0 +1,12 @@
+module purge
+module load craype-x86-genoa
+module load craype-network-ofi
+module load libfabric/1.15.2.0
+module load PrgEnv-gnu/8.3.3
+module load cray-dsmml/0.2.2
+module load cray-libsci/23.02.1.1
+module load cray-mpich/8.1.24
+module load craype/2.7.19
+module load cray-hdf5-parallel/1.12.2.1
+module load cray-netcdf-hdf5parallel/4.9.0.1
+module load cray-fftw/3.3.10.3
Index: /trunk/ARCH/arch-ADASTRA-gnu.path
===================================================================
--- /trunk/ARCH/arch-ADASTRA-gnu.path	(revision 2978)
+++ /trunk/ARCH/arch-ADASTRA-gnu.path	(revision 2978)
@@ -0,0 +1,20 @@
+NETCDF_INCDIR="-I $NETCDF_DIR/include"
+NETCDF_LIBDIR="-L $NETCDF_DIR/lib"
+NETCDF_LIB="-lnetcdf_c++4 -lnetcdf -lnetcdff "
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR=""
+HDF5_LIBDIR=""
+HDF5_LIB=""
+
+IOIPSL_INCDIR="-I$PWD/../IOIPSL/inc"
+IOIPSL_LIBDIR="-L$PWD/../IOIPSL/lib"
+IOIPSL_LIB="-lioipsl"
+
+XIOS_ROOTDIR="$PWD/../XIOS"
+XIOS_INCDIR="-I$XIOS_ROOTDIR/inc"
+XIOS_LIBDIR="-L$XIOS_ROOTDIR/lib"
+XIOS_LIB="-lxios -lstdc++"
Index: /trunk/LMDZ.COMMON/arch/arch-ADASTRA-gnu.env
===================================================================
--- /trunk/LMDZ.COMMON/arch/arch-ADASTRA-gnu.env	(revision 2978)
+++ /trunk/LMDZ.COMMON/arch/arch-ADASTRA-gnu.env	(revision 2978)
@@ -0,0 +1,12 @@
+module purge
+module load craype-x86-genoa
+module load craype-network-ofi
+module load libfabric/1.15.2.0
+module load PrgEnv-gnu/8.3.3
+module load cray-dsmml/0.2.2
+module load cray-libsci/23.02.1.1
+module load cray-mpich/8.1.24
+module load craype/2.7.19
+module load cray-hdf5-parallel/1.12.2.1
+module load cray-netcdf-hdf5parallel/4.9.0.1
+module load cray-fftw/3.3.10.3
Index: /trunk/LMDZ.COMMON/arch/arch-ADASTRA-gnu.fcm
===================================================================
--- /trunk/LMDZ.COMMON/arch/arch-ADASTRA-gnu.fcm	(revision 2978)
+++ /trunk/LMDZ.COMMON/arch/arch-ADASTRA-gnu.fcm	(revision 2978)
@@ -0,0 +1,19 @@
+%COMPILER            mpif90
+%LINK                mpif90
+%AR                  ar
+%MAKE                gmake
+%FPP_FLAGS           -P -traditional -I${FFTW_INC}
+%CPP_FLAGS           -P
+%FPP_DEF             NC_DOUBLE LAPACK BLAS SGEMV=DGEMV SGEMM=DGEMM FFT_FFTW
+%CPP_DEF             LAPACK
+%BASE_FFLAGS         -fcray-pointer -c -fdefault-real-8 -fdefault-double-8 -ffree-line-length-none -fno-align-commons -fallow-argument-mismatch  -I${FFTW_INC}
+%PROD_FFLAGS         -O3
+%DEV_FFLAGS          -O -Wall -fbounds-check
+%DEBUG_FFLAGS        -ffpe-trap=invalid,zero,overflow -fbounds-check -g3 -O0 -fstack-protector-all -finit-real=nan -fbacktrace
+%C_COMPILER          mpicc
+%C_OPTIM             -O2
+%MPI_FFLAGS          
+%OMP_FFLAGS          -fopenmp 
+%BASE_LD             -L$FFTW_DIR -lfftw3 -L$CRAY_LIBSCI_PREFIX_DIR/lib -lsci_gnu
+%MPI_LD              
+%OMP_LD              -fopenmp 
Index: /trunk/LMDZ.COMMON/arch/arch-ADASTRA-gnu.path
===================================================================
--- /trunk/LMDZ.COMMON/arch/arch-ADASTRA-gnu.path	(revision 2978)
+++ /trunk/LMDZ.COMMON/arch/arch-ADASTRA-gnu.path	(revision 2978)
@@ -0,0 +1,20 @@
+NETCDF_INCDIR="-I $NETCDF_DIR/include"
+NETCDF_LIBDIR="-L $NETCDF_DIR/lib"
+NETCDF_LIB="-lnetcdf_c++4 -lnetcdf -lnetcdff "
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR=""
+HDF5_LIBDIR=""
+HDF5_LIB=""
+
+IOIPSL_INCDIR="-I$PWD/../IOIPSL/inc"
+IOIPSL_LIBDIR="-L$PWD/../IOIPSL/lib"
+IOIPSL_LIB="-lioipsl"
+
+XIOS_ROOTDIR="$PWD/../XIOS"
+XIOS_INCDIR="-I$XIOS_ROOTDIR/inc"
+XIOS_LIBDIR="-L$XIOS_ROOTDIR/lib"
+XIOS_LIB="-lxios -lstdc++"
Index: /trunk/LMDZ.COMMON/ioipsl/install_ioipsl_ADASTRA-gnu.bash
===================================================================
--- /trunk/LMDZ.COMMON/ioipsl/install_ioipsl_ADASTRA-gnu.bash	(revision 2978)
+++ /trunk/LMDZ.COMMON/ioipsl/install_ioipsl_ADASTRA-gnu.bash	(revision 2978)
@@ -0,0 +1,66 @@
+#!/bin/bash
+# script to download and install the latest version of IOIPSL on ADASTRA with gnu compilers
+#
+
+#0. Preliminary stuff 
+
+if (( $# == 0 ))
+then
+  # default behavior: get latest version of IOIPSL
+  rev="HEAD"
+else
+  # but otherwise the first argument of the script can be the version to use
+  if (( $# == 1 ))
+  then
+    rev=$1
+  else
+    echo "Error, invalid script arguments"
+    echo "Usage:"
+    echo "$0 rev"
+    echo " where optional rev is the IOIPSL revision number"
+    exit
+  fi
+fi
+
+# cleanup possible previous attempt:
+\rm -rf ../../IOIPSL modipsl 
+
+# 1. Get IOIPSL 
+# move up at same level as LMDZ.COMMON , etc.
+cd ../..
+svn co --username icmc_users --password icmc2022 --non-interactive --revision $rev http://forge.ipsl.jussieu.fr/igcmg/svn/IOIPSL/trunk IOIPSL
+
+# 2. Set correct settings: copy over arch.* files
+cd IOIPSL
+cp -f ../LMDZ.COMMON/arch/arch-ADASTRA-gnu.env arch
+cp -f ../LMDZ.COMMON/arch/arch-ADASTRA-gnu.path arch
+cp -f ../LMDZ.COMMON/arch/arch-ADASTRA-gnu.fcm arch
+
+## 3. build ioipsl:
+./makeioipsl_fcm -arch ADASTRA-gnu -job 8 > makeioipsl.out 2>&1
+
+## 4. Check if the library was indeed built:
+whereami=`pwd -P`
+if [[ -f lib/libioipsl.a ]] 
+  then
+  echo "OK: ioipsl library is in ${whereami}/lib"
+else
+  echo "Something went wrong... check messages in ${whereami}/makeioipsl.out"
+  exit
+fi
+
+## 5. Comply with old setup and make appropriate links
+#cd ../LMDZ.COMMON/ioipsl
+#mkdir modipsl 
+#cd modipsl
+## lib + module files
+#mkdir lib
+#cd lib
+#ln -s ../../../../IOIPSL/lib/libioipsl.a .
+#ln -s ../../../../IOIPSL/inc/* .
+#cd ..
+## rebuild utility
+#mkdir bin
+#cd bin
+#ln -s ../../../../IOIPSL/bin/* .
+